---------------------------------------------------------------------
--== Import ===--
---------------------------------------------------------------------

import "Turbine.Gameplay"
import "Turbine.UI"
import "Turbine.UI.Lotro"

import "Souru.VitalSelf.Utils.Type"
import "Souru.VitalSelf.Utils.Class"
import "Souru.VitalSelf.UI"

---------------------------------------------------------------------
--==  ===--
---------------------------------------------------------------------

_G.lp = Turbine.Gameplay.LocalPlayer.GetInstance()

 WINDOW_HEIGHT = 200
-- INCOMBAT_OPACITY = 0.8
-- OUTCOMBAT_OPACITY = 0.5
-- BUFF_ICON_SIZE = 20
-- DEBUFF_ICON_SIZE = 25
-- CURABLE_ICON_SIZE = 30
-- POWER_HEIGHT = 10

-- BACK_COLOR = Turbine.UI.Color.Black
-- BUBBLE_COLOR = Turbine.UI.Color(0.53, 0.8, 0.98)
-- POWER_COLOR = Turbine.UI.Color(0.2, 0.6, 0.98)
-- BUFF_ICON_FONT = Turbine.UI.Lotro.Font.Verdana12
-- CURABLE_ICON_FONT = Turbine.UI.Lotro.Font.Verdana23
-- DEBUFF_ICON_FONT = Turbine.UI.Lotro.Font.Verdana18

---------------------------------------------------------------------
--==  ===--
---------------------------------------------------------------------

function SaveSettings()

    Turbine.PluginData.Save(Turbine.DataScope.Character, "VitalSelf", _G.settings)

end

-- ------------------------------------------------------------------------
-- Callbacks
-- ------------------------------------------------------------------------
function AddCallback(object, event, callback)
    if (object[event] == nil) then
        object[event] = callback;
    else
        if (type(object[event]) == "table") then
            table.insert(object[event], callback);
        else
            object[event] = {object[event], callback};
        end
    end
    return callback;
end

function RemoveCallback(object, event, callback)
    if (object[event] == callback) then
        object[event] = nil;
    else
        if (type(object[event]) == "table") then
            local size = table.getn(object[event]);
            for i = 1, size do
                if (object[event][i] == callback) then
                    table.remove(object[event], i);
                    break;
                end
            end
        end
    end
end



---------------------------------------------------------------------
--== functions ===--
---------------------------------------------------------------------


findfont = function(number)
    if number == 1 then
        return Turbine.UI.Lotro.Font.Arial12;
    elseif number == 2 then
        return Turbine.UI.Lotro.Font.TrajanPro13;
    elseif number == 3 then
        return Turbine.UI.Lotro.Font.TrajanPro14;
    elseif number == 4 then
        return Turbine.UI.Lotro.Font.TrajanPro15;
    elseif number == 5 then
        return Turbine.UI.Lotro.Font.TrajanPro16;
    elseif number == 6 then
        return Turbine.UI.Lotro.Font.TrajanPro18;
    elseif number == 7 then
        return Turbine.UI.Lotro.Font.TrajanPro19;
    elseif number == 8 then
        return Turbine.UI.Lotro.Font.TrajanPro20;
    elseif number == 9 then
        return Turbine.UI.Lotro.Font.TrajanPro21;
    elseif number == 10 then
        return Turbine.UI.Lotro.Font.TrajanPro23;
    elseif number == 11 then
        return Turbine.UI.Lotro.Font.TrajanPro24;
    elseif number == 12 then
        return Turbine.UI.Lotro.Font.TrajanPro25;
    elseif number == 13 then
        return Turbine.UI.Lotro.Font.TrajanPro26;
    elseif number == 14 then
        return Turbine.UI.Lotro.Font.TrajanPro28;
    elseif number == 15 then
        return Turbine.UI.Lotro.Font.TrajanProBold16;
    elseif number == 16 then
        return Turbine.UI.Lotro.Font.TrajanProBold22;
    elseif number == 17 then
        return Turbine.UI.Lotro.Font.TrajanProBold24;
    elseif number == 18 then
        return Turbine.UI.Lotro.Font.TrajanProBold25;
    elseif number == 19 then
        return Turbine.UI.Lotro.Font.TrajanProBold30;
    elseif number == 20 then
        return Turbine.UI.Lotro.Font.TrajanProBold36;
    elseif number == 21 then
        return Turbine.UI.Lotro.Font.Verdana10;
    elseif number == 22 then
        return Turbine.UI.Lotro.Font.Verdana12;
    elseif number == 23 then
        return Turbine.UI.Lotro.Font.Verdana14;
    elseif number == 24 then
        return Turbine.UI.Lotro.Font.Verdana16;
    elseif number == 25 then
        return Turbine.UI.Lotro.Font.Verdana18;
    elseif number == 26 then
        return Turbine.UI.Lotro.Font.Verdana20;
    elseif number == 27 then
        return Turbine.UI.Lotro.Font.Verdana22;
    elseif number == 28 then
        return Turbine.UI.Lotro.Font.Verdana23;
    end
end


function comma_value(amount)
    local formatted = amount
    while true do  
      formatted, k = string.gsub(formatted, "^(-?%d+)(%d%d%d)", '%1,%2')
      if (k==0) then
        break
      end
    end
    return formatted
  end

  function round(val, decimal)
    if (decimal) then
      return math.floor( (val * 10^decimal) + 0.5) / (10^decimal)
    else
      return math.floor(val+0.5)
    end
  end

  function format_number(amount, decimal)
    local str_amount,  formatted, famount, remain
  
    decimal = decimal or 2  -- default 2 decimal places
    neg_prefix = neg_prefix or "-" -- default negative sign
  
    famount = math.abs(round(amount,decimal))
    famount = math.floor(famount)
  
    remain = round(math.abs(amount) - famount, decimal)
  
          -- comma to separate the thousands
    formatted = comma_value(famount)
  
          -- attach the decimal portion
    if (decimal > 0) then
      remain = string.sub(tostring(remain),3)
      formatted = formatted .. "." .. remain ..
                  string.rep("0", decimal - string.len(remain))
    end
  
          -- attach prefix string e.g '$' 
    formatted = (prefix or "") .. formatted 
  
          -- if value is negative then format accordingly
    if (amount<0) then
      if (neg_prefix=="()") then
        formatted = "("..formatted ..")"
      else
        formatted = neg_prefix .. formatted 
      end
    end
  
    return formatted
  end


command = Turbine.ShellCommand()

function command:Execute( _, str )
    if str == nil or string.len( str ) == 0 then
        Turbine.Shell.WriteLine( "Missing Argument (move | setwidth | setheight | setframe).")
        return
    end

    local list  = { }
    local index = 1

    for word in str:gmatch( "%w+" ) do
        list[ index ] = word
        index = index + 1
    end

    local cmd = string.lower( list[ 1 ] )

    if cmd == "move" then
        vital:MoveChanged()
        SaveSettings()
    elseif cmd == "setwidth" then
        local value = tonumber(list[2])
        if value ~= nil then
            _G.settings["width"] = value
            vital:Resize()
            SaveSettings()
        end
    elseif cmd == "setheight" then
        local value = tonumber(list[2])
        if value ~= nil then
            _G.settings["height"] = value
            vital:Resize()
            SaveSettings()
        end

    elseif cmd == "setframe" then
        local value = tonumber(list[2])
        if value ~= nil then
            _G.settings["frame"] = value
            vital:Resize()
            SaveSettings()
        end
    end

end

Turbine.Shell.AddCommand( "vitalself", command )

---------------------------------------------------------------------
--== load ===--
---------------------------------------------------------------------

function FixColors()

	_G.settings["bar_color"] = Turbine.UI.Color(_G.settings["bar_color"]["R"], _G.settings["bar_color"]["G"], _G.settings["bar_color"]["B"])
	_G.settings["back_color"] = Turbine.UI.Color(_G.settings["back_color"]["R"], _G.settings["back_color"]["G"], _G.settings["back_color"]["B"])
	_G.settings["bubble_color"] = Turbine.UI.Color(_G.settings["bubble_color"]["R"], _G.settings["bubble_color"]["G"], _G.settings["bubble_color"]["B"])
	_G.settings["power_color"] = Turbine.UI.Color(_G.settings["power_color"]["R"], _G.settings["power_color"]["G"], _G.settings["power_color"]["B"])
    _G.settings["warth_color"] = Turbine.UI.Color(_G.settings["warth_color"]["R"], _G.settings["warth_color"]["G"], _G.settings["warth_color"]["B"])

end


function ColorToString(color)
	if color ~= nil then
    	return (math.round(color["R"]*255))..", "..(math.round(color["G"]*255))..", "..(math.round(color["B"]*255))
	end
end

function split(s, delimiter)
    result = {};
    for match in (s..delimiter):gmatch("(.-)"..delimiter) do
        table.insert(result, match);
    end
    return result;
end


function StringToColor(text)

    text = string.gsub(text, "\n", "")
    text = string.gsub(text, " ", "")
    local color_list = split(text, ",")

    if table.getn(color_list) == 3 then
        return color_list[1]/255, color_list[2]/255, color_list[3]/255
    else
        return nil
    end

end


if Turbine.PluginData.Load(Turbine.DataScope.Character, "VitalSelf") ~= nil then

	_G.settings = Turbine.PluginData.Load(Turbine.DataScope.Character, "VitalSelf")

    FixColors()

else

	_G.settings = {}
	_G.settings["left"] = 800
	_G.settings["top"] = 830
	_G.settings["width"] = 250
	_G.settings["height"] = 50
	_G.settings["power_height"] = 10
	_G.settings["frame"] = 2
	_G.settings["incombat_opacity"] = 0.8
	_G.settings["outcombat_opacity"] = 0.8
	_G.settings["buff_size"] = 20
	_G.settings["buff_font"] = 22
	_G.settings["debuff_size"] = 25
	_G.settings["debuff_font"] = 25
	_G.settings["curable_size"] = 30
	_G.settings["curable_font"] = 24
	_G.settings["bar_color"] = Turbine.UI.Color(0.3,0.3,0.3)
	_G.settings["back_color"] = Turbine.UI.Color.Black
	_G.settings["bubble_color"] = Turbine.UI.Color(0.53, 0.8, 0.98)
	_G.settings["power_color"] = Turbine.UI.Color(0.2, 0.6, 0.98)
    _G.settings["warth_color"] = Turbine.UI.Color(1,0.33,0.13)

	

end

vital = UI.Vital()

Turbine.UI.Lotro.LotroUI.SetEnabled(Turbine.UI.Lotro.LotroUIElement.Vitals, false)


optionsPanel = UI.Options()

optionsPanel.SizeChanged = function( sender, args )
  local optionsPanelWidth = optionsPanel:GetWidth()
  
  optionsPanel:SetHeight( optionsPanelWidth )
end

plugin.GetOptionsPanel = function( self )
  return optionsPanel
end