
BuffWindow = class( Turbine.UI.Control )

function BuffWindow:Constructor(  )
    Turbine.UI.Control.Constructor( self )

    self.items_per_row = math.floor(_G.settings["width"]/_G.settings["buff_size"])

    self:SetSize(_G.settings["width"], WINDOW_HEIGHT/2)
    self:SetMouseVisible(false)
    
    self.buffs = Turbine.UI.ListBox()
    self.buffs:SetParent(self)
    self.buffs:SetSize(_G.settings["width"], WINDOW_HEIGHT/2)
    self.buffs:SetOrientation(Turbine.UI.Orientation.Horizontal)
    self.buffs:SetMaxColumns(self.items_per_row )
    self.buffs:SetMouseVisible(false)

end

function BuffWindow:AddEffect(effect)

    
    self.buffs:AddItem(EffectIcon(effect, _G.settings["buff_size"], _G.settings["buff_font"]))
    self:Sort()

end

function BuffWindow:RemoveEffect(effect)

    for i=1, self.buffs:GetItemCount(), 1 do
        if self.buffs:GetItem(i).effect == effect then
            self.buffs:GetItem(i):Close()
            self.buffs:RemoveItem(self.buffs:GetItem(i))
            break
        end
    end

end

function BuffWindow:ClearEffects()

    for i=1, self.buffs:GetItemCount(), 1 do
        self.buffs:GetItem(i):Close()
        self.buffs:RemoveItem(self.buffs:GetItem(i))
    end

end

function BuffWindow:Sort()
    self.buffs:Sort(function(elem1,elem2) if elem1.ending>elem2.ending then return true end end)
end