EffectIcon = class( Turbine.UI.Window )

function EffectIcon:Constructor( effect, size, font )
    Turbine.UI.Window.Constructor( self )

    self.effect = effect
    self.ending = effect:GetStartTime() + effect:GetDuration()

    self:SetSize(size, size)

    self.icon = Turbine.UI.Lotro.EffectDisplay()
    self.icon:SetParent(self)
    self.icon:SetEffect(effect)
    self.icon:SetSize(size,size)
    self.icon:SetZOrder(1)

    self.labelBack = Turbine.UI.Window()
    self.labelBack:SetParent(self)
    self.labelBack:SetSize(size, size)
    self.labelBack:SetVisible(true)
    self.labelBack:SetMouseVisible(false)
    self.labelBack:SetZOrder(5)

    self.timer = Turbine.UI.Label()
    self.timer:SetParent(self.labelBack)
    self.timer:SetSize(size, size)
    self.timer:SetTextAlignment(Turbine.UI.ContentAlignment.BottomRight)
    self.timer:SetFont(findfont(font))
    self.timer:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.timer:SetMouseVisible(false)
    self.timer:SetZOrder(5)

    self.tier = Turbine.UI.Label()
    self.tier:SetParent(self.labelBack)
    self.tier:SetSize(size, size)
    self.tier:SetTextAlignment(Turbine.UI.ContentAlignment.TopLeft)
    self.tier:SetFont(findfont(font))
    self.tier:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.tier:SetForeColor(Turbine.UI.Color(0.7,0.7,0.7))
    self.tier:SetMouseVisible(false)
    self.tier:SetZOrder(5)

    self:SetVisible(true)

    if self.ending < 9999 + Turbine.Engine.GetGameTime() then
        self:SetWantsUpdates(true)
    end

    local start_tier, end_tier = string.find(effect:GetName(), "%d+")
    if start_tier ~= nil then
        self.tier:SetText(string.sub(effect:GetName(), start_tier, end_tier))
    end

end

function EffectIcon:Closing()
    self.labelBack:Close()
end

function EffectIcon:Update()

    local timeLeft = self.ending - Turbine.Engine.GetGameTime()
    if timeLeft < 0 then
        self.timer:SetText("")
    elseif timeLeft < 3 then
        self.timer:SetText(format_number(timeLeft, 1))
    elseif timeLeft < 9 then
        self.timer:SetText(format_number(timeLeft, 0))
    end

end