
Options = class( Turbine.UI.ListBox )

function Options:Constructor( )
	Turbine.UI.ListBox.Constructor( self )

	self:SetSize( 600, 600 )

    self:Header()
    self:Move()
    self:Values()

end

function Options:Header()

    local temp = Turbine.UI.Label()
    temp:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold24)
    temp:SetText("VitalSelf")
    temp:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    temp:SetSize(300,50)

    self:AddItem(temp)

end

SETTINGSFONT = Turbine.UI.Lotro.Font.Verdana18


function Options:Move()

	temp = Turbine.UI.Lotro.CheckBox()
	temp:SetWidth(600)
	temp:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
	temp:SetFont(SETTINGSFONT)
	temp:SetText(" If checked you can move the window.")
	temp:SetChecked(vital.move_window:IsVisible())
	
	temp.CheckedChanged = function()

        vital:MoveChanged()
        SaveSettings()

	end
	
    self:AddItem(temp)

end

function Options:Values()

    temp = Turbine.UI.Control()
    temp:SetSize(600, 300)

    temp.width_label = Turbine.UI.Label()
    temp.width_label:SetParent(temp)
    temp.width_label:SetFont(SETTINGSFONT)
    temp.width_label:SetText("Width")
    temp.width_label:SetPosition(10,10)
    temp.width_label:SetTextAlignment(Turbine.UI.ContentAlignment.LeftCenter)
    temp.width_label:SetSize(100, 25)

    temp.width_tb = Turbine.UI.Lotro.TextBox()
    temp.width_tb:SetParent(temp)
    temp.width_tb:SetFont(SETTINGSFONT)
    temp.width_tb:SetText(_G.settings["width"])
    temp.width_tb:SetPosition(110,10)
    temp.width_tb:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    temp.width_tb:SetSize(50, 25)


    temp.height_label = Turbine.UI.Label()
    temp.height_label:SetParent(temp)
    temp.height_label:SetFont(SETTINGSFONT)
    temp.height_label:SetText("Height")
    temp.height_label:SetPosition(10,35)
    temp.height_label:SetTextAlignment(Turbine.UI.ContentAlignment.LeftCenter)
    temp.height_label:SetSize(100, 25)

    temp.height_tb = Turbine.UI.Lotro.TextBox()
    temp.height_tb:SetParent(temp)
    temp.height_tb:SetFont(SETTINGSFONT)
    temp.height_tb:SetText(_G.settings["height"])
    temp.height_tb:SetPosition(110,35)
    temp.height_tb:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    temp.height_tb:SetSize(50, 25)


    temp.frame_label = Turbine.UI.Label()
    temp.frame_label:SetParent(temp)
    temp.frame_label:SetFont(SETTINGSFONT)
    temp.frame_label:SetText("Frame")
    temp.frame_label:SetPosition(10,60)
    temp.frame_label:SetTextAlignment(Turbine.UI.ContentAlignment.LeftCenter)
    temp.frame_label:SetSize(100, 25)

    temp.frame_tb = Turbine.UI.Lotro.TextBox()
    temp.frame_tb:SetParent(temp)
    temp.frame_tb:SetFont(SETTINGSFONT)
    temp.frame_tb:SetText(_G.settings["frame"])
    temp.frame_tb:SetPosition(110,60)
    temp.frame_tb:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    temp.frame_tb:SetSize(50, 25)

    temp.bar_color_label = Turbine.UI.Label()
    temp.bar_color_label:SetParent(temp)
    temp.bar_color_label:SetSize(100, 25)
    temp.bar_color_label:SetPosition(10, 85)
    temp.bar_color_label:SetTextAlignment(Turbine.UI.ContentAlignment.LeftCenter)
    temp.bar_color_label:SetFont(SETTINGSFONT)
    temp.bar_color_label:SetText("Bar Color")
    temp.bar_color_label:SetForeColor(Turbine.UI.Color.White)

    temp.bar_color_tb = Turbine.UI.Lotro.TextBox()
	temp.bar_color_tb:SetParent(temp)
	temp.bar_color_tb:SetSize(150,25)
	temp.bar_color_tb:SetPosition(110,85)
	temp.bar_color_tb:SetFont(SETTINGSFONT)
    temp.bar_color_tb:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    temp.bar_color_tb:SetText(ColorToString(_G.settings["bar_color"]))


    temp.back_color_label = Turbine.UI.Label()
    temp.back_color_label:SetParent(temp)
    temp.back_color_label:SetSize(100, 25)
    temp.back_color_label:SetPosition(10, 110)
    temp.back_color_label:SetTextAlignment(Turbine.UI.ContentAlignment.LeftCenter)
    temp.back_color_label:SetFont(SETTINGSFONT)
    temp.back_color_label:SetText("Back Color")
    temp.back_color_label:SetForeColor(Turbine.UI.Color.White)

    temp.back_color_tb = Turbine.UI.Lotro.TextBox()
	temp.back_color_tb:SetParent(temp)
	temp.back_color_tb:SetSize(150,25)
	temp.back_color_tb:SetPosition(110,110)
	temp.back_color_tb:SetFont(SETTINGSFONT)
    temp.back_color_tb:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    temp.back_color_tb:SetText(ColorToString(_G.settings["back_color"]))

    temp.bubble_color_label = Turbine.UI.Label()
    temp.bubble_color_label:SetParent(temp)
    temp.bubble_color_label:SetSize(100, 25)
    temp.bubble_color_label:SetPosition(10, 135)
    temp.bubble_color_label:SetTextAlignment(Turbine.UI.ContentAlignment.LeftCenter)
    temp.bubble_color_label:SetFont(SETTINGSFONT)
    temp.bubble_color_label:SetText("Bubble Color")
    temp.bubble_color_label:SetForeColor(Turbine.UI.Color.White)

    temp.bubble_color_tb = Turbine.UI.Lotro.TextBox()
	temp.bubble_color_tb:SetParent(temp)
	temp.bubble_color_tb:SetSize(150,25)
	temp.bubble_color_tb:SetPosition(110,135)
	temp.bubble_color_tb:SetFont(SETTINGSFONT)
    temp.bubble_color_tb:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    temp.bubble_color_tb:SetText(ColorToString(_G.settings["bubble_color"]))

    temp.power_color_label = Turbine.UI.Label()
    temp.power_color_label:SetParent(temp)
    temp.power_color_label:SetSize(100, 25)
    temp.power_color_label:SetPosition(10, 160)
    temp.power_color_label:SetTextAlignment(Turbine.UI.ContentAlignment.LeftCenter)
    temp.power_color_label:SetFont(SETTINGSFONT)
    temp.power_color_label:SetText("Power Color")
    temp.power_color_label:SetForeColor(Turbine.UI.Color.White)

    temp.power_color_tb = Turbine.UI.Lotro.TextBox()
	temp.power_color_tb:SetParent(temp)
	temp.power_color_tb:SetSize(150,25)
	temp.power_color_tb:SetPosition(110,160)
	temp.power_color_tb:SetFont(SETTINGSFONT)
    temp.power_color_tb:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    temp.power_color_tb:SetText(ColorToString(_G.settings["power_color"]))

    temp.warth_color_label = Turbine.UI.Label()
    temp.warth_color_label:SetParent(temp)
    temp.warth_color_label:SetSize(100, 25)
    temp.warth_color_label:SetPosition(10, 185)
    temp.warth_color_label:SetTextAlignment(Turbine.UI.ContentAlignment.LeftCenter)
    temp.warth_color_label:SetFont(SETTINGSFONT)
    temp.warth_color_label:SetText("Warth Color")
    temp.warth_color_label:SetForeColor(Turbine.UI.Color.White)

    temp.warth_color_tb = Turbine.UI.Lotro.TextBox()
	temp.warth_color_tb:SetParent(temp)
	temp.warth_color_tb:SetSize(150,25)
	temp.warth_color_tb:SetPosition(110,185)
	temp.warth_color_tb:SetFont(SETTINGSFONT)
    temp.warth_color_tb:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    temp.warth_color_tb:SetText(ColorToString(_G.settings["warth_color"]))

    temp.accept_button = Turbine.UI.Lotro.Button()
    temp.accept_button:SetParent(temp)
	temp.accept_button:SetSize(100,25)
	temp.accept_button:SetPosition(200,230)
	temp.accept_button:SetFont(SETTINGSFONT)
    temp.accept_button:SetText("Accept")
    temp.accept_button.Click = function()

        self:Accept(
            temp.width_tb:GetText(), 
            temp.height_tb:GetText(),
            temp.frame_tb:GetText(), 
            temp.bar_color_tb:GetText(),
            temp.back_color_tb:GetText(),
            temp.bubble_color_tb:GetText(),
            temp.power_color_tb:GetText(),
            temp.warth_color_tb:GetText()
        )

    end

    self:AddItem(temp)

end


function Options:Accept(width, height, frame, bar_color, back_color, bubble_color, power_color, warth_color)

    _G.settings["width"] = tonumber(width)
    _G.settings["height"] = tonumber(height)
    _G.settings["frame"] = tonumber(frame)

    _G.settings["bar_color"].R, _G.settings["bar_color"].G, _G.settings["bar_color"].B = StringToColor(bar_color)
    _G.settings["back_color"].R, _G.settings["back_color"].G, _G.settings["back_color"].B = StringToColor(back_color)
    _G.settings["bubble_color"].R, _G.settings["bubble_color"].G, _G.settings["bubble_color"].B = StringToColor(bubble_color)
    _G.settings["power_color"].R, _G.settings["power_color"].G, _G.settings["power_color"].B = StringToColor(power_color)
    _G.settings["warth_color"].R, _G.settings["warth_color"].G, _G.settings["warth_color"].B = StringToColor(warth_color)

    vital:Resize()

    SaveSettings()

end