Vital = class( Turbine.UI.Window )

function Vital:Constructor(  )
    Turbine.UI.Window.Constructor( self )

    self.width = _G.settings["width"] - (2*_G.settings["frame"])
    self.bubble_width = 1000

    self:SetSize(_G.settings["width"], WINDOW_HEIGHT + _G.settings["height"])
    self:SetPosition(_G.settings["left"], _G.settings["top"])
    self:SetMouseVisible(false)

    self.vital = Turbine.UI.Window()
    self.vital:SetParent(self)
    self.vital:SetSize(_G.settings["width"], _G.settings["height"])
    self.vital:SetTop(WINDOW_HEIGHT/2)

---------------------------------------------------------------------
--== frame (ui layer) ===--
---------------------------------------------------------------------

    self.vital_frame = Turbine.UI.Window()
    self.vital_frame:SetParent(self.vital)
    self.vital_frame:SetSize(_G.settings["width"], _G.settings["height"])
    self.vital_frame:SetMouseVisible(false)
    self.vital_frame:SetZOrder(2)

---------------------------------------------------------------------
--== background ===--
    self.vital_background = Turbine.UI.Control()
    self.vital_background:SetParent(self.vital_frame)
    self.vital_background:SetPosition(_G.settings["frame"], _G.settings["frame"])
    self.vital_background:SetSize(_G.settings["width"] - (2*_G.settings["frame"]), _G.settings["height"] - (2*_G.settings["frame"]))
    self.vital_background:SetBackColor(_G.settings["back_color"])
    self.vital_background:SetMouseVisible(false)

---------------------------------------------------------------------
--== moraleBar ===--
    self.vital_moraleBar = Turbine.UI.Control()
    self.vital_moraleBar:SetParent(self.vital_frame)
    self.vital_moraleBar:SetPosition(_G.settings["frame"], _G.settings["frame"])
    self.vital_moraleBar:SetSize(_G.settings["width"] - (2*_G.settings["frame"]), _G.settings["height"] - (2*_G.settings["frame"]))
    self.vital_moraleBar:SetBackColor(_G.settings["bar_color"])
    self.vital_moraleBar:SetMouseVisible(false)

---------------------------------------------------------------------
--== bubbleBar ===--
    self.vital_bubbleBar = Turbine.UI.Control()
    self.vital_bubbleBar:SetParent(self.vital_frame)
    self.vital_bubbleBar:SetHeight(_G.settings["height"] - (2*_G.settings["frame"]))
    self.vital_bubbleBar:SetTop(_G.settings["frame"])
    self.vital_bubbleBar:SetBackColor(_G.settings["bubble_color"])
    self.vital_bubbleBar:SetMouseVisible(false)
    self.vital_bubbleBar:SetZOrder(10)


---------------------------------------------------------------------
--== powerFrame ===--
    self.vital_powerFrame = Turbine.UI.Window()
    self.vital_powerFrame:SetParent(self.vital)
    self.vital_powerFrame:SetTop(self.vital:GetHeight() - _G.settings["frame"])
    self.vital_powerFrame:SetSize(_G.settings["width"], _G.settings["power_height"])
    self.vital_powerFrame:SetMouseVisible(false)
    self.vital_powerFrame:SetZOrder(1)


---------------------------------------------------------------------
--== powerBackground ===--
    self.vital_powerBackground = Turbine.UI.Control()
    self.vital_powerBackground:SetParent(self.vital_powerFrame)
    self.vital_powerBackground:SetPosition(_G.settings["frame"], _G.settings["frame"])
    self.vital_powerBackground:SetSize(_G.settings["width"] - (2*_G.settings["frame"]), _G.settings["power_height"]  - (2*_G.settings["frame"]))
    self.vital_powerBackground:SetBackColor(_G.settings["back_color"])
    self.vital_powerBackground:SetMouseVisible(false)

---------------------------------------------------------------------
--== powerBar ===--
    self.vital_powerBar = Turbine.UI.Control()
    self.vital_powerBar:SetParent(self.vital_powerBackground)
    self.vital_powerBar:SetSize(_G.settings["width"] - (2*_G.settings["frame"]), _G.settings["power_height"]  - (2*_G.settings["frame"]))
    self.vital_powerBar:SetMouseVisible(false)


---------------------------------------------------------------------
--== textlayer ===--
---------------------------------------------------------------------
    self.textLayer = Turbine.UI.Window()
    self.textLayer:SetParent(self.vital)
    self.textLayer:SetPosition(_G.settings["frame"], _G.settings["frame"])
    self.textLayer:SetSize(_G.settings["width"] - (2*_G.settings["frame"]), _G.settings["height"] - (2*_G.settings["frame"]))
    self.textLayer:SetMouseVisible(false)
    self.textLayer:SetZOrder(3)

---------------------------------------------------------------------
--== name ===--
    self.name = Turbine.UI.Label()
    self.name:SetParent(self.textLayer)
    self.name:SetSize(self.textLayer:GetSize())
    self.name:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.name:SetFont(Turbine.UI.Lotro.Font.Verdana20)
    self.name:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.name:SetText(" ".._G.lp:GetName())

---------------------------------------------------------------------
--== moraleLabel ===--
    self.moraleLabel = Turbine.UI.Label()
    self.moraleLabel:SetParent(self.textLayer)
    self.moraleLabel:SetSize(self.textLayer:GetSize())
    self.moraleLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight)
    self.moraleLabel:SetFont(Turbine.UI.Lotro.Font.Verdana16)
    self.moraleLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)


---------------------------------------------------------------------
--== entitylayer ===--
---------------------------------------------------------------------

    self.entityControl = Turbine.UI.Lotro.EntityControl()
    self.entityControl:SetParent(self.vital)
    self.entityControl:SetSize(self.vital:GetSize())
    self.entityControl:SetEntity(_G.lp)
    self.entityControl:SetZOrder(4)


---------------------------------------------------------------------
--== movelayer ===--
---------------------------------------------------------------------

    self.move_window = Turbine.UI.Window()
    self.move_window:SetParent(self)
    self.move_window:SetMouseVisible(false)
    self.move_window:SetVisible(false)
    self.move_window:SetSize(_G.settings["width"], WINDOW_HEIGHT + _G.settings["height"])
    self.move_window:SetZOrder(10)

    self.move_window.MouseDown = function( sender, args )
		if args.Button == Turbine.UI.MouseButton.Left then
			self.dragging = true	
			self.dragStartX = args.X
            self.dragStartY = args.Y
		end
	end
	
	self.move_window.MouseMove = function( sender, args )
		if self.dragging then
			local x,y = self:GetPosition()
			x = x + ( args.X - self.dragStartX )
            y = y + ( args.Y - self.dragStartY )
            self:SetPosition( x, y )
		end
	end
	
	self.move_window.MouseUp = function( sender, args )
		if args.Button == Turbine.UI.MouseButton.Left then
			self.dragging = false
			_G.settings["left"],_G.settings["top"] = self:GetPosition()
				
			SaveSettings()
		end
    end

---------------------------------------------------------------------
--== functions ===--
---------------------------------------------------------------------

---------------------------------------------------------------------
--== targetchanged ===--
    self:SelfTargetChanged()
    AddCallback(_G.lp, "TargetChanged", function() self:SelfTargetChanged() end)

---------------------------------------------------------------------
--== mouse enter/leave ===--
    -- self.vital.MouseEnter = function()
    --     local target = _G.lp:GetTarget()
    --     -- if target == nil or not(target:IsLocalPlayer()) then
    --     --     self.vital_frame:SetBackColor(Turbine.UI.Color(0.1,0.1,0.1))
    --     --     self.vital_bubbleFrame:SetBackColor(Turbine.UI.Color(0.1,0.1,0.1))
    --     -- end

    --     self.vital_frame:SetOpacity(_G.settings["incombat_opacity"])
    --     self.vital_powerFrame:SetOpacity(_G.settings["incombat_opacity"])

    -- end

    -- self.vital.MouseLeave = function()
    --     self:SelfTargetChanged()
    --     self:SelfCombatChanged()
    -- end

---------------------------------------------------------------------
--== moralechanged ===--
    self:SelfMoraleChanged()
    AddCallback(_G.lp, "MaxMoraleChanged", function() self:SelfMoraleChanged() end)
    AddCallback(_G.lp, "MoraleChanged", function() self:SelfMoraleChanged() end)


---------------------------------------------------------------------
--== powerchanged ===--
    if _G.lp:GetClass() == Turbine.Gameplay.Class.Beorning then
        self.vital_powerBar:SetBackColor(_G.settings["warth_color"])
        self:SelfWrathChanged()
        AddCallback(_G.lp:GetClassAttributes(), "WrathChanged", function() self:SelfWrathChanged() end)
    else
        self.vital_powerBar:SetBackColor(_G.settings["power_color"])
        self:SelfPowerChanged()
        AddCallback(_G.lp, "MaxPowerChanged", function() self:SelfPowerChanged() end)
        AddCallback(_G.lp, "PowerChanged", function() self:SelfPowerChanged() end)
    end

---------------------------------------------------------------------
--== bubblechanged ===--
    self:SelfBubbleChanged()
    AddCallback(_G.lp, "MaxTemporaryMoraleChanged", function() self:SelfBubbleChanged() end)
    AddCallback(_G.lp, "TemporaryMoraleChanged", function() self:SelfBubbleChanged() end)

---------------------------------------------------------------------
--== combatchanged ===--
    self:SelfCombatChanged()
    AddCallback(_G.lp, "InCombatChanged", function() self:SelfCombatChanged() end)

---------------------------------------------------------------------
--== visible ===--
    self.textLayer:SetVisible(true)
    self:SetVisible(true)
    self.vital:SetVisible(true)
    self.vital_frame:SetVisible(true)
    self.vital_powerFrame:SetVisible(true)

---------------------------------------------------------------------
--== effects ===--
---------------------------------------------------------------------

    self.buffs = BuffWindow()
    self.buffs:SetParent(self)
    self.buffs:SetTop(self.vital:GetTop() + self.vital:GetHeight() + self.vital_powerFrame:GetHeight())

    self.debuffs = DebuffWindow()
    self.debuffs:SetParent(self)
    self.debuffs:SetTop(0)

---------------------------------------------------------------------
--== effecttrigger ===--

    self.lp_effects = _G.lp:GetEffects()

    for i=1, self.lp_effects:GetCount(), 1 do
        local effect = self.lp_effects:Get(i)
        if effect:IsDebuff() then
            self.debuffs:AddEffect(effect)
        else
            self.buffs:AddEffect(effect)
        end
    end

    AddCallback(self.lp_effects, "EffectAdded", function(sender, args)
        local effect = self.lp_effects:Get(args.Index)
        if effect:IsDebuff() then
            self.debuffs:AddEffect(effect)
        else
            self.buffs:AddEffect(effect)
        end
    end)

    AddCallback(self.lp_effects, "EffectRemoved", function(sender, args)
        if args.Effect:IsDebuff() then
            self.debuffs:RemoveEffect(args.Effect)
        else
            self.buffs:RemoveEffect(args.Effect)
        end
    end)

    AddCallback(self.lp_effects, "EffectsCleared", function(sender, args)
        self.buffs:ClearEffects()
        self.debuffs:ClearEffects()
        for i=1, self.lp_effects:GetCount(), 1 do
            local effect = self.lp_effects:Get(i)
            if effect:IsDebuff() then
                self.debuffs:AddEffect(effect)
            else
                self.buffs:AddEffect(effect)
            end
        end
    end)


end

function Vital:SelfCombatChanged()

    if _G.lp:IsInCombat() then
        self.vital_frame:SetOpacity(_G.settings["incombat_opacity"])
        self.vital_powerFrame:SetOpacity(_G.settings["incombat_opacity"])
    else
        self.vital_frame:SetOpacity(_G.settings["outcombat_opacity"])
        self.vital_powerFrame:SetOpacity(_G.settings["outcombat_opacity"])
    end

end

function Vital:MoveChanged()

    local bool = not(self.move_window:IsVisible())
    self.move_window:SetVisible(bool)
    self.move_window:SetMouseVisible(bool)
end


function Vital:SelfBubbleChanged()

    local b = _G.lp:GetTemporaryMorale()

    if b > 0 then
        
        local maxm = _G.lp:GetMaxMorale()
        local maxb = _G.lp:GetMaxTemporaryMorale()

        local percent = b/maxm 
        local width = percent * self.width

        self.vital_bubbleBar:SetWidth(width)
        self.vital_bubbleBar:SetLeft(self.width + _G.settings["frame"] - math.floor( width ))

        self.vital_bubbleBar:SetVisible(true)
    else
        self.vital_bubbleBar:SetVisible(false)
    end

end

function Vital:SelfMoraleChanged()

    local maxm = _G.lp:GetMaxMorale()
    local m = _G.lp:GetMorale()

    local percent = m/maxm

    self.vital_moraleBar:SetWidth(self.width*percent)
    self.moraleLabel:SetText((math.floor(m/100)/10).."k - "..math.floor(percent*100).."% ")

end

function Vital:SelfPowerChanged()

    local maxp = _G.lp:GetMaxPower()
    local p = _G.lp:GetPower()

    local percent = p/maxp

    self.vital_powerBar:SetWidth(self.width*percent)
    --self.moraleLabel:SetText((math.floor(m/100)/10).."k - "..math.floor(percent*100).."% ")

end

function Vital:SelfWrathChanged()

    local maxw = 100
    local w = _G.lp:GetClassAttributes():GetWrath()

    local percent = w/maxw

    self.vital_powerBar:SetWidth(self.width*percent)

end

function Vital:SelfTargetChanged()

    local target = _G.lp:GetTarget()
    if target == nil or not(target:IsLocalPlayer()) then
        self.vital_frame:SetBackColor(Turbine.UI.Color.Black)
        self.vital_powerFrame:SetBackColor(Turbine.UI.Color.Black)
    else
        self.vital_frame:SetBackColor(Turbine.UI.Color.White)
        self.vital_powerFrame:SetBackColor(Turbine.UI.Color.White)
    end

end


function Vital:Resize()

    
    self.width = _G.settings["width"] - (2*_G.settings["frame"])

    self:SetSize(_G.settings["width"], WINDOW_HEIGHT + _G.settings["height"])
    self.vital:SetSize(_G.settings["width"], _G.settings["height"])
    self.vital_frame:SetSize(_G.settings["width"], _G.settings["height"])
    self.vital_background:SetPosition(_G.settings["frame"], _G.settings["frame"])
    self.vital_background:SetSize(_G.settings["width"] - (2*_G.settings["frame"]), _G.settings["height"] - (2*_G.settings["frame"]))
    self.vital_moraleBar:SetPosition(_G.settings["frame"], _G.settings["frame"])
    self.vital_moraleBar:SetSize(_G.settings["width"] - (2*_G.settings["frame"]), _G.settings["height"] - (2*_G.settings["frame"]))
    self.vital_bubbleBar:SetHeight(_G.settings["height"] - (2*_G.settings["frame"]))
    self.vital_bubbleBar:SetTop(_G.settings["frame"])
    self.vital_powerFrame:SetTop(self.vital:GetHeight() - _G.settings["frame"])
    self.vital_powerFrame:SetSize(_G.settings["width"], _G.settings["power_height"])
    self.vital_powerBackground:SetPosition(_G.settings["frame"], _G.settings["frame"])
    self.vital_powerBackground:SetSize(_G.settings["width"] - (2*_G.settings["frame"]), _G.settings["power_height"]  - (2*_G.settings["frame"]))
    self.vital_powerBar:SetSize(_G.settings["width"] - (2*_G.settings["frame"]), _G.settings["power_height"]  - (2*_G.settings["frame"]))
    self.textLayer:SetPosition(_G.settings["frame"], _G.settings["frame"])
    self.textLayer:SetSize(_G.settings["width"] - (2*_G.settings["frame"]), _G.settings["height"] - (2*_G.settings["frame"]))
    self.name:SetSize(self.textLayer:GetSize())
    self.moraleLabel:SetSize(self.textLayer:GetSize())
    self.entityControl:SetSize(self.vital:GetSize())
    self.move_window:SetSize(_G.settings["width"], WINDOW_HEIGHT + _G.settings["height"])

    self.vital_moraleBar:SetBackColor(_G.settings["bar_color"])
    self.vital_background:SetBackColor(_G.settings["back_color"])
    self.vital_bubbleBar:SetBackColor(_G.settings["bubble_color"])

    self:SelfMoraleChanged()
    self:SelfBubbleChanged()

    if _G.lp:GetClass() == Turbine.Gameplay.Class.Beorning then
        self:SelfWrathChanged()
        self.vital_powerBar:SetBackColor(_G.settings["warth_color"])
    else
        self:SelfPowerChanged()
        self.vital_powerBar:SetBackColor(_G.settings["power_color"])
    end

end